function [Gr, Gi, symbol] = gaborfilter1(scale, orientation, shad);

expand = 12; b = floor(scale * expand+.5); 
theta = (pi * orientation)/180; 
Gauss = zeros(b+b+1); 
Gcos = zeros(b+b+1); Gsin = zeros(b+b+1);
symbol = zeros(b+b+1); mask = zeros(b+b+1);
for x0 = -b : b
    for y0 = -b : b
        if (x0^2+y0^2>b^2) 
            fac = 0;  
        else
            fac = 1; 
        end
        x = (x0 * cos(theta) + y0 * sin(theta))/scale;
        y = (y0 * cos(theta) - x0 * sin(theta))/scale;
        g = exp(-(4*x^2+y^2)/100)/50/pi/scale^2; 
        Gauss(b+x0+1,b+y0+1) = g*fac; 
        Gcos(b+x0+1, b+y0+1) = g*cos(x)*fac;
        Gsin(b+x0+1, b+y0+1) = g*sin(x)*fac;
        symbol(b+x0+1, b+y0+1) = (abs(x)<3.4)*fac*shad;
    end
end
s = sum(Gauss(:)); sc = sum(Gcos(:)); r = sc/s; 
Gcos = Gcos - Gauss*r; 
Scos = sqrt(sum(sum(Gcos.^2))); Ssin = sqrt(sum(sum(Gsin.^2)));
Gr = Gcos/Scos; Gi = Gsin/Ssin; 









